<?php

function fca_pc_premium_save( $data ) {

	//PREMIUM SETTINGS
	$data['utm_support'] = empty( $_POST['fca_pc']['utm_support'] ) ? '' : 'on';
	$data['user_parameters'] = empty( $_POST['fca_pc']['user_parameters'] ) ? '' : 'on';
	$data['advanced_matching'] = empty( $_POST['fca_pc']['advanced_matching'] ) ? '' : 'on';
	$data['amp_integration'] = empty( $_POST['fca_pc']['amp_integration'] ) ? '' : 'on';

	//WOOCOMMERCE SETTINGS
	$data['woo_integration'] = empty( $_POST['fca_pc']['woo_integration'] ) ? '' : 'on';
	$data['woo_extra_params'] = empty( $_POST['fca_pc']['woo_extra_params'] ) ? '' : 'on';
	$data['woo_delay'] = empty( $_POST['fca_pc']['woo_delay'] ) ? 0 : intVal( $_POST['fca_pc']['woo_delay'] );

	//WOOCOMMERCE FEED
	$data['woo_feed'] = empty( $_POST['fca_pc']['woo_feed'] ) ? '' : 'on';
	$data['woo_excluded_categories'] = empty( $_POST['fca_pc']['woo_excluded_categories'] ) ? array() : array_map( 'fca_pc_sanitize_text_array', $_POST['fca_pc']['woo_excluded_categories'] );
	$data['woo_product_id'] = empty( $_POST['fca_pc']['woo_product_id'] ) ? 'post_id' : sanitize_text_field( $_POST['fca_pc']['woo_product_id'] );
	$data['woo_desc_mode'] = empty( $_POST['fca_pc']['woo_desc_mode'] ) ? 'description' : sanitize_text_field( $_POST['fca_pc']['woo_desc_mode'] );
	$data['google_product_category'] = empty( $_POST['fca_pc']['google_product_category'] ) ? '' : intval( $_POST['fca_pc']['google_product_category'] );

	//EDD SETTINGS
	$data['edd_integration'] = empty( $_POST['fca_pc']['edd_integration'] ) ? '' : 'on';
	$data['edd_delay'] = empty( $_POST['fca_pc']['edd_delay'] ) ? 0 : intVal( $_POST['fca_pc']['edd_delay'] );
	$data['edd_extra_params'] = empty( $_POST['fca_pc']['edd_extra_params'] ) ? '' : 'on';

	//EDD FEED
	$data['edd_feed'] = empty( $_POST['fca_pc']['edd_feed'] ) ? '' : 'on';
	$data['edd_excluded_categories'] = empty( $_POST['fca_pc']['edd_excluded_categories'] ) ? array() : array_map( 'fca_pc_sanitize_text_array', $_POST['fca_pc']['edd_excluded_categories'] );
	$data['edd_desc_mode'] = empty( $_POST['fca_pc']['edd_desc_mode'] ) ? 'content' : sanitize_text_field( $_POST['fca_pc']['edd_desc_mode'] );

	//VIDEO EVENTS SETTINGS
	$data['video_events'] = empty( $_POST['fca_pc']['video_events'] ) ? '' : 'on';

	return $data;
}

function fca_pc_editor_premium_data() {
	$premium_data = array(
		'customParamTemplate' => fca_pc_custom_param_row(),
	);

	wp_localize_script( 'fca_pc_admin_js', 'fcaPcPremiumData', $premium_data );
}


function fca_pc_multi_capi_event( $options ){

	$pixels = empty( $options['pixels'] ) ? array() : $options['pixels'];

	forEach( $pixels as $pixel ){

		$pixel = json_decode( stripslashes_deep( $pixel ), TRUE );
		$pixel_id = $pixel['pixel'];
		$capi_token = empty( $pixel['capi'] ) ? '' : $pixel['capi'];
		$test_code = empty( $pixel['test'] ) ? '' : $pixel['test'];
		$paused = $pixel['paused'];
			
		if( $pixel_id && !$paused && $capi_token ){
			fca_pc_fb_api_call( $pixel_id, $capi_token, $test_code );
		} 

	}
}

function fca_pc_multi_pixel_init( $options ) {

	$code = '';
	$advanced_matching = empty( $options['advanced_matching'] ) ? false : true;
	$pixels = empty( $options['pixels'] ) ? array() : $options['pixels'];

	forEach ( $pixels as $pixel ) {

		$pixel = json_decode( stripslashes_deep( $pixel ), TRUE );
		$pixel_id = fca_pc_clean_pixel_id( $pixel['pixel'] );
		$paused = $pixel['paused'];

		if( !$paused ){

			if ( $advanced_matching ) {
				$code .= "fbq( 'init', '$pixel_id', " . fca_pc_advanced_matching() . " );";
			} else {
				$code .= "fbq( 'init', '$pixel_id' );";
			}

		}

	}

	return $code;

}

